<%-- $Id:index.jsp 4187 2008-03-20 11:15:25Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.util.HTML"
 	import="net.sf.basedb.util.extensions.ExtensionPoint"
	import="net.sf.basedb.util.extensions.Extension"
	import="net.sf.basedb.util.extensions.logging.ExtensionsLogger"
	import="net.sf.basedb.util.extensions.logging.ExtensionsLog"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
	final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final String cmd = request.getParameter("cmd");
final String root = request.getContextPath()+"/";

String forward = null;
String redirect = null;
String message = null;
DbControl dc = null;
try
{
	if (cmd == null || "List".equals(cmd))
	{
		forward = "manager.jsp";
	}
	else if ("EnableExtension".equals(cmd))
	{
		String extensionId = request.getParameter("extensionId");
		boolean enable = Values.getBoolean(request.getParameter("enable"));
		dc = sc.newDbControl(":"+(enable?"Enable":"Disable")+" extension: "+extensionId);
		ExtensionsControl ec = ExtensionsControl.get(dc);
		ec.enableExtension(extensionId, enable);
		ec.saveSettings();
		redirect = "details.jsp?ID=" + ID + "&extensionId=" + extensionId;
	}
	else if ("EnableExtensionPoint".equals(cmd))
	{
		String extensionPointId = request.getParameter("extensionPointId");
		boolean enable = Values.getBoolean(request.getParameter("enable"));
		dc = sc.newDbControl(":"+(enable?"Enable":"Disable")+"  extension point: "+extensionPointId);
		ExtensionsControl ec = ExtensionsControl.get(dc);
		ec.enableExtensionPoint(extensionPointId, enable);
		ec.saveSettings();
		redirect = "details.jsp?ID=" + ID + "&extensionPointId=" + extensionPointId;
	}
	else if ("EnableFile".equals(cmd))
	{
		String fileuri = request.getParameter("fileuri");
		boolean enable = Values.getBoolean(request.getParameter("enable"));
		dc = sc.newDbControl(":"+(enable?"Enable":"Disable")+"  file: "+fileuri);
		ExtensionsControl ec = ExtensionsControl.get(dc);
		ec.enableAllInFile(fileuri, enable);
		dc.commit();
		ec.saveSettings();
		redirect = "details.jsp?ID=" + ID + "&fileuri=" + HTML.urlEncode(fileuri);
	}
	else if ("ManualScan".equals(cmd))
	{
		forward = "wizard.jsp?ID=" + ID;
	}
	else if ("DoManualScan".equals(cmd))
	{
		dc = sc.newDbControl(":Extensions installation wizard");
		ExtensionsControl ec = ExtensionsControl.get(dc);
		ec.performActions(request);
		dc.commit();

		redirect = "index.jsp?ID=" + ID + "&cmd=ScanResults";
	}
	else if ("ScanResults".equals(cmd))
	{
		forward = "scan_results.jsp?ID=" + ID;
	}
	else if ("ClearLog".equals(cmd))
	{
		String extensionId = request.getParameter("extensionId");
		ExtensionsLog serviceLog = ExtensionsLog.getLog(extensionId, false);
		if (serviceLog != null)
		{
			serviceLog.clearLog();
			serviceLog.createLogger().info("The log was cleared by "+sc.getLoggedInUserName()+" ("+sc.getLoggedInUserLogin()+")");
		}
		redirect = "view_log.jsp?ID="+ID+"&extensionId="+HTML.urlEncode(extensionId);
	}
	else if ("SetLogOptions".equals(cmd))
	{
		String extensionId = request.getParameter("extensionId");
		boolean enableDebug = Values.getBoolean(request.getParameter("enableDebug"));
		boolean copyToStdout = Values.getBoolean(request.getParameter("copyToStdout"));
		boolean autoUpdate = Values.getBoolean(request.getParameter("autoUpdate"));
		ExtensionsLog serviceLog = ExtensionsLog.getLog(extensionId, true);
		ExtensionsLogger logger = serviceLog.createLogger();
		if (copyToStdout != serviceLog.isCopyingToStdout())
		{
			if (!copyToStdout) logger.info("Stop copy to stdout");
			serviceLog.setCopyToStdout(copyToStdout);
			if (copyToStdout) logger.info("Start copy to stdout");
		}
		if (enableDebug != serviceLog.isDebugEnabled())
		{
			if (!enableDebug) logger.debug("Debug logging was disabled");
			serviceLog.setDebugEnabled(enableDebug);
			if (enableDebug) logger.debug("Debug logging was enabled");
		}
		redirect = "view_log.jsp?ID="+ID+"&extensionId="+HTML.urlEncode(extensionId)+"&autoUpdate="+autoUpdate;
	}
	else
	{
		throw new WebException("popup", "Invalid command", "The command {1} is not recognised as a valid command.", cmd);
	}
}
finally
{
	if (dc != null) dc.close();
}

if (forward != null)
{
	sc.setSessionSetting("alert-message", message);
	pageContext.forward(forward);
}
else if (redirect != null)
{
	sc.setSessionSetting("alert-message", message);
	response.sendRedirect(redirect);
}
else if (message == null)
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&wait=0");
}
else
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&message="+HTML.urlEncode(message));
}
%>

