/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2012 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
*/
'use strict';

var Help = function()
{
	var help = {};
	
	/**
		Initialize the page.
	*/
	help.initPage = function()
	{
		// Buttons
		Buttons.addClickHandler('close', App.closeWindow);
		Buttons.addClickHandler('btnBack', help.goBack);
		Buttons.addClickHandler('btnEdit', help.editOnClick);
		Buttons.addClickHandler('btnNew', help.newOnClick);
		if (history.length == 1) Doc.hide('btnBack');
	}
	
	help.editOnClick = function(event)
	{
		var helpId = Data.int('page-data', 'help-id');
		var externalId = Data.get('page-data', 'external-id');
		var clientId = Data.int('page-data', 'client-id');
		Items.editItem('HELP', helpId, '&client_id='+clientId+'&external_id='+externalId);
	}
	
	help.newOnClick = function(event)
	{
		var externalId = Data.get('page-data', 'external-id');
		var clientId = Data.int('page-data', 'client-id');
		Items.newItem('HELP', '&client_id='+clientId+'&external_id='+externalId);
	}
	
	help.goBack = function()
	{
		history.go(-1);
	}
	
	return help;
}();

Doc.onLoad(Help.initPage);