/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2012 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
*/
'use strict';

var Info = function()
{
	var info = {};

	info.initElements = function(element, autoInit)
	{
		if (autoInit == 'edit-annotation')
		{
			Buttons.addClickHandler(element, info.editAnnotation);
		}
		else if (autoInit == 'edit-inherited-annotation')
		{
			Buttons.addClickHandler(element, info.editInheritedAnnotation);
		}
		else if (autoInit == 'edit-data-file')
		{
			Buttons.addClickHandler(element, info.editDataFile);
		}
		else if (autoInit == 'edit-item')
		{
			Buttons.addClickHandler(element, info.editItem);
		}
	}
	
	info.editItem = function(event)
	{
		var target = event.currentTarget;
		var itemType = Data.get(target, 'item-type');
		var itemId = Data.get(target, 'item-id');
		Items.editItem(itemType, itemId);
	}
	
	info.editDataFile = function(event)
	{
		var target = event.currentTarget;
		var itemType = Data.get(target, 'item-type');
		var itemId = Data.get(target, 'item-id');
		Items.editItem(itemType, itemId, '&tab=datafiles');
	}

	info.editAnnotation = function(event)
	{
		var target = event.currentTarget;
		var itemType = Data.get(target, 'item-type');
		var itemId = Data.get(target, 'item-id');
		var annotationId = Data.get(target, 'annotation-id');
		var annotationTypeId = Data.get(target, 'annotation-type-id');
		var url = App.getRoot() + 'common/annotations/annotate.jsp?ID='+App.getSessionId();
		url += '&item_type=' + itemType;
		url += '&item_id=' + itemId;
		url += '&annotationtype_id='+annotationTypeId;
		url += '&annotation_id='+annotationId;
		url += '&standalone=1';
		Dialogs.openPopup(url, 'EditAnnotation', 750, 500);
	}
	
	info.editInheritedAnnotation = function(event)
	{
		var target = event.currentTarget;
		var itemType = Data.get(target, 'item-type');
		var itemId = Data.get(target, 'item-id');
		var annotationTypeId = Data.get(target, 'annotation-type-id');
		var url = App.getRoot() + 'common/annotations/inherit.jsp?ID='+App.getSessionId();
		url += '&item_type='+itemType;
		url += '&item_id='+itemId;
		url += '&annotationtype_id='+annotationTypeId;
		url += '&standalone=1';
		Dialogs.openPopup(url, 'EditAnnotation', 750, 500);
	}
	
	return info;
}();

Doc.addElementInitializer(Info.initElements);


