/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2021 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
*/
'use strict';

var FileManager = function()
{
	var manager = {};
	

	manager.initPage = function()
	{
		Events.addEventHandler(document.body, 'drop', manager.noDragDrop);
		Events.addEventHandler(document.body, 'dragover', manager.noDragDrop);
	}

	manager.noDragDrop = function(event)
	{
		event.dataTransfer.dropEffect = "none";
		// Stop all default things from happening
		event.preventDefault();
		event.stopPropagation();
	}

	return manager;
}();

Doc.onLoad(FileManager.initPage);


